<?php
require 'Zend/Loader.php';

/**
 * The Bootstrap
 *
 * @author TAAT
 * @link http://taat.pl
 * @version 1.0
 */
class Bootstrap
{
    // PROPERTIES
    /**
     * Front controller instance
     * @access public static
     * @var object Zend_Controller_Front
     */
    public static $frontController = null;

    /**
     * root directory
     * @access public static
     * @var string
     */
    public static $root = '';

    /**
     * Run app
     * @access public static
     * @return null
     */
    // PUBLIC METHODS
    public static function run ()
    {
        self::setupEnvironment();
        self::setup();
        $response = self::$frontController->dispatch();
        self::sendResponse($response);
    }

    /**
     * Prepare Front Controller and View
     * @access public static
     * @return null
     */
    public static function setup ()
    {
        self::setupFrontController();
        self::setupView();
    }

    /**
     * setup environment
     * @access public static
     * @param
     * @return null
     */
    public static function setupEnvironment ()
    {
        error_reporting(E_ALL | E_STRICT);
        ini_set('display_errors', true);
        date_default_timezone_set('Europe/Warsaw');
        self::$root = dirname(dirname(__FILE__));
        set_include_path(
                         get_include_path() .
                         PATH_SEPARATOR . self::$root . '/library/'
                        );
    }

    /**
     * Prepare front controller
     * @access public static
     * @param
     * @return null
     */
    public static function setupFrontController ()
    {
        Zend_Loader::registerAutoload();
        self::$frontController = Zend_Controller_Front::getInstance();
        self::$frontController->throwExceptions(true);
        self::$frontController->setParam('noErrorHandler', false);
        self::$frontController->returnResponse(true);
        self::$frontController->addControllerDirectory(self::$root .  '/application/modules/default/controllers');
    }

    /**
     * Setup View
     * @access public static
     * @return null
     */
    public static function setupView ()
    {
        self::$frontController->registerPlugin(new My_View_Setup());
    }

	/**
	* Setup Model
	* @access public static
	* @return null
	*/
    public static function setupDatabase ()
    {
        // TODO Setup database
    }

    /**
     * Send response to the browser
     * @access public static
     * @param  Zend_Controller_Response_Http $response
     * @return null
     */
    public static function sendResponse (Zend_Controller_Response_Http $response)
    {
        $response->setHeader('Content-Type', 'text/html; charset=UTF-8');
        // $response->setHeader( 'Accept-encoding', 'gzip,deflate');
        $response->sendResponse();
    }
}